 #!/bin/sh
  #
 exec tclsh "$0" "$@"

package require Tk
 package require Tkhtml
 package require Img
 ####################################
 proc allerA { liste} {
 #-----------------------------------
 global Historique
 global Rang
set Rang 0

   foreach {nom target} $liste break
   if {$nom!=""} {
	 set fichier [lindex $nom 0]
	 set elems [split $fichier #]
	 set nom [lindex $elems 0]
	 set ancre [lindex $elems 1]
	 if { [ file exists $nom ] } {
	   set car [string range $nom 0 0]
	   if { $car=="/" } {
		 set chem  [file dirname $nom]
		 } else {
		 set chem [pwd]/[file dirname $nom]
		 set chem [file normalize $chem]
		 }
	   set fic [file tail $nom]
	   set txt $chem/$fic
	   if {$ancre!=""} { set txt $txt#$ancre }
	   set Historique [linsert $Historique $Rang $txt]
	   set nbh [llength $Historique]
	   #set Rang 0
	   if {$nbh>12} {set Historique [lreplace $Historique end end] }
	   presenterFichier $txt
	   }
	 }
   }
 ###################################
 proc presenterFichier { fichier } {
 #----------------------------------
 # presentation du fichier $fichier
 # fichier de la forme nom#ancre
 #----------------------------------
 set elems [split $fichier #]
 set nom [lindex $elems 0]
 set ancre [lindex $elems 1]
 cd [file dirname $nom]

 if { [ file exists $nom ] } {
   set f [open $nom]
   set t [read $f]
   .visu.c.h clear
   .visu.c.h config -base $f
   .visu.c.h parse $t
   close $f
   if {$ancre!="" } {
	 update idletasks
	 .visu.c.h yview $ancre
	 }
   set t1 [.visu.c.h token find "title"]
   if {$t1==""} {
	 .visu.e.titre configure -text ""
	 } else {
	 set t2 [.visu.c.h token find "/title"]
	 set l [.visu.c.h text ascii [lindex $t1 0] [lindex $t2 0]]
	 .visu.e.titre configure -text [string trim $l]
	 }
   }
 }
 ##############################
 proc mettreImage { args } {
 #-----------------------------
 # procédure appllée par tkhtml pour placer
 # une image dans la page html
 #------------------------------------
   set fn [lindex $args 0]
   set fic $fn
   if { [file exists $fic]==1 } {
	 set rep [ catch { image create photo -file $fic} img ]
	 if { $rep==0 } {
	   return $img
	   }
	 }
   }
 ############################################
 proc changeCaracteres { taille attrs} {
 #------------------------------------------
   set chgt ""
   set t [expr 14 + 2*($taille-4) ]
   lappend chgt $t
   if { [lsearch $attrs bold] >=0 } { lappend chgt bold }
   if { [lsearch $attrs italic] >=0 } { lappend chgt o }
   set fonte -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
   if { [lsearch $attrs fixed] >=0 } {
	 set fonte -*-courrier-medium-r-*-*-12-*-*-*-*-*-*-*
	 }
   set rep $fonte
   if { $chgt != "" } {
	 set rep [ changeFonte $fonte $chgt ]
	 }
   return $rep
   }
 #=========================================
 proc changeFonte { fonte change } {
 #------------------------------------
 # change=liste des changements à la fonte
 # r=droit, o=oblique
 # medium=normal bold=gras
 # helvetica, courier, times, arial, ....
 # 8, 10 12, 14, ...
 #---------------------------------------
 set elems [split $fonte -]
 foreach chg $change {
	set pos 2
	switch $chg {
		r -
		o { set pos 4}
		medium -
		bold { set pos 3}
		8 -
		10 -
		11 -
		12 -
		14 -
	16 -
	18 { set pos 7}
		}
	set elems [lreplace $elems $pos $pos $chg]
	}
 set rep [join $elems -]
 return $rep
 }
 #====================================
 proc pagePrecedente {  } {
 #------------------------------------
  global Historique
  global Rang
  puts "pagePrecedente: Historique=$Historique"
  puts "Rang=$Rang"
  set max [llength $Historique]
  if {$Rang < [expr $max-1] } {
	incr Rang
	set nom [lindex $Historique $Rang ]
	presenterFichier $nom
	}
  }
 #====================================
 proc pageSuivante {  } {
 #------------------------------------
  global Historique
  global Rang
  puts "pageSuivante: Historique=$Historique"
  puts "Rang=$Rang"
  if { $Rang > 0 } {
	incr Rang -1
	set nom [lindex $Historique $Rang ]
	presenterFichier $nom
	}
  }
 #######################################
 wm minsize . 630 300
 wm geometry . 720x550

 #  le fichier à consulter est donné en argument
 frame .visu
 pack .visu -side top -fill both -expand 1
 frame .visu.e
 pack .visu.e -fill x -side top
 pack [label .visu.e.ar -text "<=" ] -side left
 pack [label .visu.e.av -text "=>" ] -side left
 bind .visu.e.ar <1> "pagePrecedente"
 bind .visu.e.av <1> "pageSuivante"
 label .visu.e.titre -padx 10 -fg #777777
 pack .visu.e.titre -side right

 frame .visu.c
 pack .visu.c -side top -fill both -expand 1
 html .visu.c.h \
  -yscrollcommand { .visu.c.vsb set} \
  -padx 4 \
  -pady 7 \
  -fontcommand  changeCaracteres \
  -imagecommand mettreImage \
  -underlinehyperlinks  1 \
  -bg white -tablerelief raised

 pack .visu.c.h -side left -fill both -expand 1
 scrollbar .visu.c.vsb -orient vertical -command { .visu.c.h yview}
 pack .visu.c.vsb -side right -fill y

 frame .visu.p
 pack .visu.p -fill x
 label .visu.p.l -padx 4 -font -*-helvetica-medium-r-*-*-12-*-*-*-*-*-*-*
 pack .visu.p.l -side left

 bind .visu.c.h.x <1> {
  .visu.c.h selection clear
  set Pclic %x,%y
  set ref [.visu.c.h href %x %y]
  if {[llength $ref]} {
	allerA $ref
	}
  }
 bind .visu.c.h.x <B1-Motion> {
  %W selection set @$::Pclic @%x,%y
  clipboard clear
  catch {
	 clipboard append [selection get]
	}
  }
 bind HtmlClip <Motion> {
  set parent [winfo parent %W]
  set url [$parent href %x %y]
  if {[string length $url] > 0} {
	$parent configure -cursor hand2
	.visu.p.l configure -text [lindex $url 0]
	} else {
	$parent configure -cursor {}
	.visu.p.l configure -text ""
	}
  }

proc Tikeditor::Aide { var } {
		variable application
		variable version
		global Chemin
		
		
		if [winfo exists .aide] {	destroy .aide}
		toplevel .aide
		bell -displayof .aide
		wm title .aide "Aide $application $version"
		wm resizable .aide true true


#<interface_aide>

frame .aide.f
	pack .aide.f -side top
	label .aide.f.labelFonte -text " Taille des caractères "
	label .aide.f.reclic -text "Rechargez la page après modification de la taille des caractères"
	button .aide.f.plus -text " + " -command { Tikeditor::PolicePlusAide .aide.fenetreHtm}
	  button .aide.f.moins -text " _ " -command { Tikeditor::PoliceMoinsAide .aide.fenetreHtm}
	  pack .aide.f.labelFonte .aide.f.plus .aide.f.moins .aide.f.reclic -side left


text .aide.sommaire -background lavender  -foreground BlueViolet -width 18 -height 15 -cursor arrow  -font  {helvetica 12}
text .aide.fenetreHtm -height 15 -font  {times 10}	-width 50 -yscrollcommand " .aide.y set"
scrollbar .aide.y -orient vertical -command {.aide.fenetreHtm yview} 
pack .aide.sommaire .aide.fenetreHtm   -expand true	-fill y  -side left 
pack .aide.y  -expand true  -fill y  -side left

wm resizable .aide false true
	
#<tags_sommaire_aide>
foreach tag {t0 t1 t2 t3 t4 t5 t6 t7 t8 t9} {
	.aide.sommaire tag bind $tag <Any-Enter> ".aide.sommaire tag configure $tag -foreground white -background  RosyBrown " 
	.aide.sommaire tag bind $tag <Any-Leave> ".aide.sommaire tag configure $tag -foreground BlueViolet  -background  lavender"
}

#<insertion_sommaire_aide>
.aide.sommaire insert end "Aide \n" t0
.aide.sommaire  insert end "Généralités \n" t1
.aide.sommaire  insert end "Menus \n" t2
.aide.sommaire  insert end "Menus classiques\n" t3
.aide.sommaire  insert end "Menus spéciaux\n" t4
.aide.sommaire  insert end "Icônes \n" t5
.aide.sommaire  insert end "Touches magiques\n" t6
.aide.sommaire  insert end "Marques\n" t7
.aide.sommaire  insert end "Masques\n" t8
.aide.sommaire  insert end "Colorisation\n" t9


#<liens_tags_fichiersHtml_aide_tikeditor>

set fichierHtml [ open  [file join $Chemin(rel) aide accueil.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml

HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "

.aide.sommaire  tag bind t0 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide accueil.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm ;  HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t1 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide generalites.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t2 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide menus.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}

.aide.sommaire  tag bind t3 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide menus_classiques.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}


.aide.sommaire  tag bind t4 <1> { set fichierHtml [ open  [file join $Chemin(rel) aide menus_programmation.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
HMreset_win .aide.fenetreHtm ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm "}


.aide.sommaire  tag bind t5 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide icones.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t6 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide touchesMagiques.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t7 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide marques.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t8 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide masque.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }

.aide.sommaire  tag bind t9 <1> {set fichierHtml [ open  [file join $Chemin(rel) aide colorisation.htm ] ]
set aideAffiche [ read -nonewline $fichierHtml ]
close $fichierHtml
 HMreset_win .aide.fenetreHtm  ;  HMinit_win .aide.fenetreHtm  ;	HMparse_html $aideAffiche "HMrender .aide.fenetreHtm " }


bind .aide.sommaire  <3> { destroy .aide}
bind  .aide.fenetreHtm  <3> { destroy .aide}

		return 0
	  }
		
	
	
 set nom [lindex $argv 0]
 cd [file dirname $nom]
 set Historique $nom
#£  set Rang 0
 presenterFichier $nom

